## field3d 1.6.1

=== CMakeLists.txt ===
# Copyright (c) 2009 Sony Pictures Imageworks Inc. et al.
# 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the
# distribution. Neither the name of Sony Pictures Imageworks nor the
# names of its contributors may be used to endorse or promote
# products derived from this software without specific prior written
# permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.

# Author : Nicholas Yue yue.nicholas@gmail.com

CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

PROJECT ( field3d )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake )

FIND_PACKAGE (Doxygen)
FIND_PACKAGE (HDF5)
IF ( CMAKE_HOST_WIN32 )
# f3dinfo relies on program_options but don't include it, since
# for some reason, unlike all the other boost components, a link is
# forced via a pragma.
FIND_PACKAGE (Boost COMPONENTS regex thread)
ELSE ()
FIND_PACKAGE (Boost COMPONENTS regex thread program_options system)
FIND_PACKAGE (MPI)
ENDIF ()

FIND_PACKAGE (ILMBase)

OPTION (INSTALL_DOCS "Automatically install documentation." ON)

# Duplicate the export directory to Field3D
FILE ( REMOVE_RECURSE ${CMAKE_HOME_DIRECTORY}/Field3D)
FILE ( COPY export/ DESTINATION ${CMAKE_HOME_DIRECTORY}/Field3D)

# includes
INCLUDE_DIRECTORIES ( . )
INCLUDE_DIRECTORIES ( src )
INCLUDE_DIRECTORIES ( export )
INCLUDE_DIRECTORIES ( ${ILMBASE_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES ( ${HDF5_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES ( ${Boost_INCLUDE_DIR} )

# link directories
LINK_DIRECTORIES ( ${Boost_LIBRARY_DIRS} )
LINK_DIRECTORIES ( ${HDF5_LIBRARY_DIRS} )
LINK_DIRECTORIES ( ${ILMBASE_LIBRARY_DIRS} )

IF ( CMAKE_HOST_UNIX )
  ADD_DEFINITIONS ( -fPIC -DREQUIRE_IOSTREAM -Wno-invalid-offsetof )
ENDIF ( )
IF ( CMAKE_HOST_WIN32 )
  ADD_DEFINITIONS ( 
    -DOPENEXR_DLL 
    -D_HDF5USEDLL_ 
    -DHDF5CPP_USEDLL 
    -D_HAS_ITERATOR_DEBUGGING=0 
    -D_CRT_SECURE_NO_WARNINGS=1
    )
ENDIF ( )

ADD_LIBRARY ( Field3D SHARED
  src/ClassFactory.cpp
  src/DenseFieldIO.cpp
  src/Field3DFile.cpp
  src/Field.cpp
  src/FieldInterp.cpp
  src/FieldMapping.cpp
  src/FieldMappingIO.cpp
  src/FileSequence.cpp
  src/Hdf5Util.cpp
  src/InitIO.cpp
  src/Log.cpp
  src/MACFieldIO.cpp
  src/MIPFieldIO.cpp
  src/MIPUtil.cpp
  src/PatternMatch.cpp
  src/PluginLoader.cpp
  src/ProceduralField.cpp
  src/Resample.cpp
  src/SparseFieldIO.cpp
  src/SparseFile.cpp
)

SET ( Field3D_Libraries_Shared
  ${HDF5_LIBRARIES}
  )

IF ( CMAKE_HOST_UNIX )
  IF ( MPI_FOUND )
      LIST ( APPEND Field3D_Libraries_Shared
             ${MPI_LIBRARIES} )
  ENDIF ( MPI_FOUND )
  LIST ( APPEND Field3D_Libraries_Shared
    Iex Half IlmThread Imath
    pthread dl z )
  SET ( Field3D_DSO_Libraries ${Field3D_Libraries_Shared} )
  SET ( Field3D_BIN_Libraries Field3D ${Field3D_Libraries_Shared}
        ${Boost_LIBRARIES} )
ENDIF ( )
IF ( CMAKE_HOST_WIN32 )
  # Add OpenEXR and zlib release/debug
  FOREACH ( lib Iex Half IlmThread Imath zdll )
    LIST ( APPEND Field3D_Libraries_Shared
      optimized ${lib}
      debug ${lib}_d )
  ENDFOREACH()
  SET ( Field3D_DSO_Libraries ${Field3D_Libraries_Shared} )
  SET ( Field3D_BIN_Libraries Field3D ${Boost_LIBRARIES} )
ENDIF ()

TARGET_LINK_LIBRARIES ( Field3D ${Field3D_DSO_Libraries} ${Boost_LIBRARIES})

# Parase version and soversion from export/ns.h

file(STRINGS export/ns.h FIELD3D_MAJOR_VER REGEX "^#define FIELD3D_MAJOR_VER")
file(STRINGS export/ns.h FIELD3D_MINOR_VER REGEX "^#define FIELD3D_MINOR_VER")
file(STRINGS export/ns.h FIELD3D_MICRO_VER REGEX "^#define FIELD3D_MICRO_VER")
string(REPLACE "#define FIELD3D_MAJOR_VER " "" FIELD3D_MAJOR_VER ${FIELD3D_MAJOR_VER})
string(REPLACE "#define FIELD3D_MINOR_VER " "" FIELD3D_MINOR_VER ${FIELD3D_MINOR_VER})
string(REPLACE "#define FIELD3D_MICRO_VER " "" FIELD3D_MICRO_VER ${FIELD3D_MICRO_VER})
SET ( FIELD3D_VERSION ${FIELD3D_MAJOR_VER}.${FIELD3D_MINOR_VER}.${FIELD3D_MICRO_VER} )
SET ( FIELD3D_SOVERSION ${FIELD3D_MAJOR_VER}.${FIELD3D_MINOR_VER} )

message(STATUS "Library soversion will be: ${FIELD3D_SOVERSION}")

SET_TARGET_PROPERTIES ( Field3D PROPERTIES VERSION ${FIELD3D_VERSION})
SET_TARGET_PROPERTIES ( Field3D PROPERTIES SOVERSION ${FIELD3D_SOVERSION})

IF ( CMAKE_HOST_WIN32 )
  SET_TARGET_PROPERTIES( Field3D PROPERTIES ENABLE_EXPORTS ON )
  SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_DEFINITIONS FIELD3D_EXPORT )
  SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -EHsc )
  SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -MD )
  SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -wd4251 )
ENDIF ( )



# field3d - unitTest
ADD_EXECUTABLE ( unitTest
  test/unit_tests/UnitTest.cpp
  )

TARGET_LINK_LIBRARIES ( unitTest ${Field3D_BIN_Libraries} )

IF ( CMAKE_HOST_WIN32 )
  SET_TARGET_PROPERTIES( unitTest PROPERTIES COMPILE_FLAGS -bigobj )
ENDIF ( )

# field3d - f3dinfo
ADD_EXECUTABLE ( f3dinfo
  apps/f3dinfo/main.cpp
  )

TARGET_LINK_LIBRARIES ( f3dinfo ${Field3D_BIN_Libraries} )

# field3d - sparse_field_io
ADD_EXECUTABLE ( sparse_field_io
  apps/sample_code/sparse_field_io/main.cpp
  )

TARGET_LINK_LIBRARIES ( sparse_field_io ${Field3D_BIN_Libraries} )

# field3d - read
ADD_EXECUTABLE ( read
  apps/sample_code/read/main.cpp
  )

TARGET_LINK_LIBRARIES ( read ${Field3D_BIN_Libraries} )

# field3d - mixed_types
ADD_EXECUTABLE ( mixed_types
  apps/sample_code/mixed_types/main.cpp
  )

TARGET_LINK_LIBRARIES ( mixed_types ${Field3D_BIN_Libraries} )

# field3d - create_and_write
ADD_EXECUTABLE ( create_and_write
  apps/sample_code/create_and_write/main.cpp
  )

TARGET_LINK_LIBRARIES ( create_and_write ${Field3D_BIN_Libraries} )

IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET ( doc
    ALL
    ${DOXYGEN_EXECUTABLE} Field3D.doxyfile
    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}
    )
  IF (INSTALL_DOCS)
    INSTALL (DIRECTORY 
      ${CMAKE_HOME_DIRECTORY}/docs
      DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
  ENDIF (INSTALL_DOCS)
ENDIF (DOXYGEN_FOUND)

INSTALL ( TARGETS
  Field3D
  DESTINATION lib${LIB_SUFFIX}
)

FILE(GLOB Field3d_Includes  "${CMAKE_CURRENT_SOURCE_DIR}/export/*.h")

INSTALL ( FILES 
  ${Field3d_Includes} 
  DESTINATION include/Field3D
)

INSTALL ( TARGETS f3dinfo 
  RUNTIME DESTINATION bin
)

=== SConstruct ===
#
# Copyright (c) 2009 Sony Pictures Imageworks Inc. 
# 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the
# distribution. Neither the name of Sony Pictures Imageworks nor the
# names of its contributors may be used to endorse or promote
# products derived from this software without specific prior written
# permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.

# ------------------------------------------------------------------------------

from BuildSupport import *

# ------------------------------------------------------------------------------

env = Environment()

Export("env")

SConscript("SConscript")

# ------------------------------------------------------------------------------

=== debian/changelog ===
field3d (1.6.1-2) unstable; urgency=medium

  * Update watch file, now tracks upstream tags.
  * Bump standards version to 3.9.7, no changes required.
  * Use secure VCS-Git URI.
  * Use system jquery.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 10 Feb 2016 16:00:03 +0000

field3d (1.6.1-1) unstable; urgency=low

  * Initial release. Closes: #810311

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 15 Jan 2016 09:22:07 +0000

=== debian/control ===
Source: field3d
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libhdf5-dev,
               libilmbase-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/field3d.git
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/field3d.git
Homepage: https://sites.google.com/site/field3d/

Package: field3d-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line tools for the Field3D library
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the command-line tools for the Field3D library.

Package: field3d-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: documentation and examples for the Field3D library
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the documentation and example source code for the
 Field3D library.

Package: libfield3d1.6
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for storing voxel data on disk and in memory
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the Field3D library.

Package: libfield3d-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libboost-system-dev,
         libboost-thread-dev,
         libfield3d1.6 (= ${binary:Version}),
         libhdf5-dev,
         libilmbase-dev,
         ${misc:Depends}
Suggests: field3d-doc
Description: development files for the Field3D library
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the development files for the Field3D library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#DH_VERBOSE = 1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX="/$(DEB_TARGET_MULTIARCH)"
		-DINSTALL_DOCS=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && [ -x unitTest ] && ./unitTest
endif

override_dh_install-indep:
	dh_install --indep
	dh_doxygen --indep

override_dh_installexamples-indep:
	dh_installexamples --indep --exclude=SCon*

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/field3d-$1\.tar\.gz/ \
https://github.com/imageworks/Field3D/tags .*/v?(\d\S*)\.tar\.gz

## field3d 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,9 @@
 
 FIND_PACKAGE (ILMBase)
 
+# Allow the developer to select if Dynamic or Static libraries are built
+OPTION (BUILD_SHARED_LIBS "Build Shared Libraries" ON)
+
 OPTION (INSTALL_DOCS "Automatically install documentation." ON)
 
 # Duplicate the export directory to Field3D
@@ -74,16 +77,30 @@
   ADD_DEFINITIONS ( -fPIC -DREQUIRE_IOSTREAM -Wno-invalid-offsetof )
 ENDIF ( )
 IF ( CMAKE_HOST_WIN32 )
-  ADD_DEFINITIONS ( 
-    -DOPENEXR_DLL 
-    -D_HDF5USEDLL_ 
-    -DHDF5CPP_USEDLL 
+  ADD_DEFINITIONS (
     -D_HAS_ITERATOR_DEBUGGING=0 
     -D_CRT_SECURE_NO_WARNINGS=1
     )
 ENDIF ( )
 
-ADD_LIBRARY ( Field3D SHARED
+SET ( LIB_TYPE SHARED )
+IF ( NOT BUILD_SHARED_LIBS )
+  IF ( CMAKE_HOST_WIN32 )
+  # User wants to build static libraries, so change the LIB_TYPE variable to CMake keyword 'STATIC'
+    SET ( LIB_TYPE STATIC )
+    ADD_DEFINITIONS( -DFIELD3D_STATIC )
+  ENDIF()
+ELSE ()
+  IF ( CMAKE_HOST_WIN32 )
+    ADD_DEFINITIONS (
+        -DOPENEXR_DLL
+        -D_HDF5USEDLL_
+        -DHDF5CPP_USEDLL
+        )
+  ENDIF()
+ENDIF ( NOT BUILD_SHARED_LIBS )
+
+ADD_LIBRARY ( Field3D ${LIB_TYPE}
   src/ClassFactory.cpp
   src/DenseFieldIO.cpp
   src/Field3DFile.cpp
@@ -129,7 +146,7 @@
       optimized ${lib}
       debug ${lib}_d )
   ENDFOREACH()
-  SET ( Field3D_DSO_Libraries ${Field3D_Libraries_Shared} )
+  SET ( Field3D_DSO_Libraries ${Field3D_Libraries_Shared} Shlwapi.lib)
   SET ( Field3D_BIN_Libraries Field3D ${Boost_LIBRARIES} )
 ENDIF ()
 
@@ -153,7 +170,11 @@
 
 IF ( CMAKE_HOST_WIN32 )
   SET_TARGET_PROPERTIES( Field3D PROPERTIES ENABLE_EXPORTS ON )
-  SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_DEFINITIONS FIELD3D_EXPORT )
+  IF ( BUILD_SHARED_LIBS )
+    SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_DEFINITIONS FIELD3D_EXPORT )
+  ELSE ()
+    SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_DEFINITIONS FIELD3D_STATIC )
+  ENDIF()
   SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -EHsc )
   SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -MD )
   SET_TARGET_PROPERTIES( Field3D PROPERTIES COMPILE_FLAGS -wd4251 )

=== debian/changelog ===
field3d (1.6.2-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:17:28 +0000

field3d (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * d/gbp.conf: change packaging branch to debian/master (DEP-14).
  * d/watch: fix filename mangling regex.
  * d/copyright: fix text of BSD license.
  * d/control: cme fix, wrap and sort.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 15 Mar 2016 09:46:12 +0000

=== debian/control ===
--- 
+++ 
@@ -67,12 +67,12 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libboost-system-dev,
+Depends: ${misc:Depends},
+         libboost-system-dev,
          libboost-thread-dev,
          libfield3d1.6 (= ${binary:Version}),
          libhdf5-dev,
-         libilmbase-dev,
-         ${misc:Depends}
+         libilmbase-dev
 Suggests: field3d-doc
 Description: development files for the Field3D library
  Field3D is an open source library for storing voxel data.

## field3d 1.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -64,6 +64,7 @@
 INCLUDE_DIRECTORIES ( . )
 INCLUDE_DIRECTORIES ( src )
 INCLUDE_DIRECTORIES ( export )
+INCLUDE_DIRECTORIES ( include )
 INCLUDE_DIRECTORIES ( ${ILMBASE_INCLUDE_DIRS} )
 INCLUDE_DIRECTORIES ( ${HDF5_INCLUDE_DIRS} )
 INCLUDE_DIRECTORIES ( ${Boost_INCLUDE_DIR} )
@@ -104,17 +105,30 @@
   src/ClassFactory.cpp
   src/DenseFieldIO.cpp
   src/Field3DFile.cpp
+  src/Field3DFileHDF5.cpp
+  src/FieldCache.cpp
   src/Field.cpp
   src/FieldInterp.cpp
   src/FieldMapping.cpp
   src/FieldMappingIO.cpp
+  src/FieldMetadata.cpp
   src/FileSequence.cpp
   src/Hdf5Util.cpp
+  src/IArchive.cpp
+  src/IData.cpp
+  src/IGroup.cpp
   src/InitIO.cpp
+  src/IStreams.cpp
   src/Log.cpp
   src/MACFieldIO.cpp
   src/MIPFieldIO.cpp
   src/MIPUtil.cpp
+  src/OArchive.cpp
+  src/OData.cpp
+  src/OgIGroup.cpp
+  src/OGroup.cpp
+  src/OgUtil.cpp
+  src/OStream.cpp
   src/PatternMatch.cpp
   src/PluginLoader.cpp
   src/ProceduralField.cpp

=== debian/changelog ===
field3d (1.7.2-1build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:13:21 +0000

field3d (1.7.2-1build1) zesty; urgency=medium

  * Rebuild against new hdf5

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 29 Nov 2016 17:33:25 +0000

field3d (1.7.2-1) unstable; urgency=medium

  * Rename field3d-bin package to field3d-tools.
  * Minor improvements to control file.
    - Re-order list of binary packages.
    - Move tools package to utils section.
    - Update description for all packages.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 10 Sep 2016 23:47:36 +0100

field3d (1.7.2-1~exp2) experimental; urgency=medium

  * Disable testing on big-endian architectures.
  * Query and use DEB_HOST_MULTIARCH instead.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 10 Sep 2016 10:36:30 +0100

field3d (1.7.2-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop Fix-missing-include-directory.patch, applied upstream.
  * Bump Standards-Version to 3.9.8, no changes required.
  * Remove unused lintian override.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jun 2016 12:39:54 +0100

field3d (1.7.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright:
    - Add upstream contact.
    - Add copyright information for new files.
    - Update selected copyright formatting.
  * Bump soversion of shlib package.
  * Simplify lintian-overrides regex for shlib package.
  * d/gbp.conf: disable patch numbering with gbp-pq.
  * Add patch fixing FTBFS due to a missing include directory.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 13 Apr 2016 11:58:48 +0100

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Field3D-$1\.tar\.gz/ \
https://github.com/imageworks/Field3D/tags .*/v?(\d\S*)\.tar\.gz

## field3d 1.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,7 @@
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake )
 
 FIND_PACKAGE (Doxygen)
-FIND_PACKAGE (HDF5)
+FIND_PACKAGE (HDF5 COMPONENTS C)
 IF ( CMAKE_HOST_WIN32 )
 # f3dinfo relies on program_options but don't include it, since
 # for some reason, unlike all the other boost components, a link is

=== SConstruct ===
--- 
+++ 
@@ -36,7 +36,7 @@
 
 # ------------------------------------------------------------------------------
 
-env = Environment()
+env = Environment(CXXFLAGS="-std=c++11")
 
 Export("env")

=== apps/f3dinfo/SConstruct ===
# ------------------------------------------------------------------------------

env = Environment()

Export("env")

SConscript("SConscript")

# ------------------------------------------------------------------------------

=== test/misc_tests/lib_perf_test/SConstruct ===
SConscript("SConscript")

=== debian/changelog ===
field3d (1.7.3-6) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version: 4.7.2
  * d/control:
      - binary Package: field3d-doc add Multi-Arch: foreign
      - update Homepage https://github.com/imageworks/Field3D/wiki/Field3D-Home
  * d/p/fix_boost183.patch: add Forwarded: not-needed
  * d/rules: remove export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
  * d/copyright: update year info to 2025
  * rm d/libfield3d1.7t64.lintian-overrides, useless
  * add d/clean
  * add d/gbp.conf

 -- xiao sheng wen <atzlinux@debian.org>  Mon, 18 Aug 2025 17:44:07 +0800

field3d (1.7.3-5) unstable; urgency=medium

  * Team upload.
  * d/rules: Adding -DH5_USE_110_API to CFLAGS and CXXFLAGS, Closes: #1078975
      Thanks Gilles Filippini, Pierre Gruet
  * d/gbp.conf:
      - update debian-branch = debian/sid
      - remove debian-tag line, it's the default value of gbp.conf

 -- xiao sheng wen <atzlinux@debian.org>  Mon, 06 Jan 2025 10:05:08 +0800

field3d (1.7.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062589

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 08:35:41 +0000

field3d (1.7.3-4) unstable; urgency=medium

  * Team upload.
  * Fix compilation againts boost 1.83. (Closes: #1056082)

 -- Anton Gladky <gladk@debian.org>  Wed, 27 Dec 2023 13:39:37 +0100

field3d (1.7.3-3) unstable; urgency=medium

  * Team upload.

  * debian/control: IlmBase -> OpenEXR for -dev
  * debian/tests/: fix autopkgtests

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 04 Mar 2023 14:30:12 +0100

field3d (1.7.3-2) unstable; urgency=medium

  * Team upload.

  * Upload to unstable (Closes: #939660)

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 19 Feb 2023 17:58:53 +0100

field3d (1.7.3-1) experimental; urgency=medium

  * Team upload.

  * New upstream release
  * debian/patches/: patchset updated
    - Add_OpenEXR_3.x_support.patch added (Closes: #1023719)
  * debian/: debhelper bump 9 -> 13
  * debian/control:
    - Testsuite field dropped
    - S-V bump 3.9.8 -> 4.6.2 (no changes needed)
    - RRR field set
    - Vcs-* fields updated
    - libilmbase-dev -> libopenexr-dev for bdeps
  * debian/copyright: http:// -> https://
  * debian/watch: 3 -> 4 version bump
  * debian/tests/: ADTTMP variable updated

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 19 Feb 2023 13:53:20 +0100

=== debian/control ===
Source: field3d
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libhdf5-dev,
               libopenexr-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/imageworks/Field3D/wiki/Field3D-Home
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/field3d
Vcs-Git: https://salsa.debian.org/debian-phototools-team/field3d.git

Package: libfield3d1.7t64
Provides: ${t64:Provides}
Replaces: libfield3d1.7
Breaks: libfield3d1.7 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for storing voxel data on disk and in memory
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the shared libraries.

Package: libfield3d-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libboost-system-dev,
         libboost-thread-dev,
         libfield3d1.7t64 (= ${binary:Version}),
         libhdf5-dev,
         libopenexr-dev
Suggests: field3d-doc
Description: development files for Field3D
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the development files.

Package: field3d-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: documentation for Field3D
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the documentation.

Package: field3d-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: field3d-bin (<< 1.7.2-1)
Replaces: field3d-bin (<< 1.7.2-1)
Description: command-line tools for Field3D
 Field3D is an open source library for storing voxel data.
 .
 It provides C++ classes that handle in-memory storage and a file format
 based on HDF5 that allows the C++ objects to be written to and read from
 disk.
 .
 This package contains the command-line tools.

=== debian/rules ===
--- 
+++ 
@@ -3,23 +3,35 @@
 # Uncomment this to turn on verbose mode.
 #DH_VERBOSE = 1
 
+DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture --query DEB_HOST_ARCH_ENDIAN)
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture --query DEB_HOST_MULTIARCH)
+
 # Hardening flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
 export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+# HDF5 1.14.x flags
+export DEB_CFLAGS_MAINT_APPEND = -DH5_USE_110_API
+export DEB_CXXFLAGS_MAINT_APPEND = -DH5_USE_110_API
 
 %:
-	dh $@  
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DLIB_SUFFIX="/$(DEB_TARGET_MULTIARCH)"
+		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"
 		-DINSTALL_DOCS=ON
 
+# NOTE: The Ogawa feature introduced in 1.7.x is not supported for big-endian
+# architectures. Upstream has yet to adapt the testsuite, so all we can do is
+# disable testing if the host architecture is big-endian for now.
+# See: https://github.com/imageworks/Field3D/issues/90
 override_dh_auto_test:
+ifneq (big,$(DEB_HOST_ARCH_ENDIAN))
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	cd obj-* && [ -x unitTest ] && ./unitTest
+endif
 endif
 
 override_dh_install-indep:

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Field3D-$1\.tar\.gz/ \
https://github.com/imageworks/Field3D/tags .*/v?(\d\S*)\.tar\.gz
